(*
 * Copyright (c) 2014 Leo White <leo@lpw25.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *)

open Odoc_document

type args = {
  semantic_uris : bool;
  closed_details : bool;
  indent : bool;
  theme_uri : Odoc_html.Tree.uri;
  support_uri : Odoc_html.Tree.uri;
  flat : bool;
}

let render args page =
  Odoc_html.Link.semantic_uris := args.semantic_uris;
  Odoc_html.Tree.open_details := not args.closed_details;
  Odoc_html.Link.flat := args.flat;
  Odoc_html.Generator.render ~theme_uri:args.theme_uri
    ~support_uri:args.support_uri ~indent:args.indent page

let files_of_url url = [ Odoc_html.Link.Path.as_filename url ]

let renderer = { Renderer.name = "html"; render; files_of_url }
